/*************************************************************************
copyright: (c) 2000-7 Hilofumi Yamamoto
Time-stamp: "2007-06-30 16:31:54 yamagen"
*************************************************************************/
#include <stdio.h>
#include <string.h>
#include "config.h"

#define S_MAX 1024
#define FALSE 0
#define TRUE 1
/* #define DEBUG 0 */


int iskanji(int, int);
int digitstr(char *);
void dance(FILE *, int, char *);
int main(int, char **);

#ifdef SJIS
int code_type = 1; /* default sjis */
#else
int code_type = 0; /* default euc */
#endif

int iskanji(c, t)
int c;
int t;
{
  if (t)
    return((0x81 <= c && c <= 0x9F) || (0xE0 <= c && c <= 0xFC)); /* SJIS */
  else 
    return(0x8E <= c && c <= 0xFE && 0x8F != c && c != 0xA0);     /* EUC  */
}

int digitstr(str)
char *str;
{
  if (*str == '\0')
    return FALSE;
  for (; *str != '\0'; str++) {
    if (!isdigit(*str))
      return FALSE;
  }
  return TRUE;
}


void dance(ifp, nof, deli)
FILE *ifp;
int nof;
char *deli;
{

  int c, c1, c2, i = 0, j;
  int n = 0;
  int inbtw = 0, rvs = 0;
  char r[S_MAX]; /* max string size */

  /* 1եɤϥǥե */
  if (nof == 1) { /* if it's the first field, then set true */
    rvs = TRUE;
  }else{
    rvs = FALSE;     
  }

  while ((c = getc(ifp)) != EOF) {
    if(c == *deli){ /* found a delimiter character! */
      if (rvs) {      /* print out the string reversely */
	while (i) { 
	  putchar(r[i--]);
	} 
      }

      putchar(c);
      c = getc(ifp);
      
      inbtw++; 
      if (nof - 1 == inbtw) { /* ξˤϡ1 */
	rvs = TRUE;
         }else{
	rvs = FALSE;     
      }

    } /* the end of 'a delimiter found' */



    if(c == '\n'){ /* in case of '\n' */
      
      if(rvs){
	while(i){ 
	  putchar(r[i--]);
	} 
      }

      putchar(c);
      c=getc(ifp);
      inbtw = 0; 

      if (nof == 1) { /* ϤΥեɤоݤξˤϡ1 */
	rvs = TRUE;
      }else{
	rvs = FALSE;
      }

    } /* the end of '\n' */


    if(rvs){ /* of target to be reversed */
      if(iskanji(c,code_type)){
	c2 = getc(ifp);
	r[++i] = c2;
	r[++i] = c;
      }else{
	r[++i] = c;
      }
    }else{
      putchar(c); /* output as it is */
    }

  }
}

void usage(prog)
char *prog;
{
  fprintf(stderr,
	  "Usage: %% %s [-Fn -Dc -sehv]\n"
	  "     Fn .. (n)th the field will be reversed (default 1).\n"
	  "     Dc .. (c)haracter will be regarded as a delimiter (default '|').\n"
#ifdef SJIS
	  "     s ... SJIS Kanji code (default)\n"
	  "     e ... EUC  Kanji code\n"
#else
	  "     s ... SJIS Kanji code\n"
	  "     e ... EUC  Kanji code (default)\n"
#endif
	  "     v ... shows Version\n"
	  "     h ... shows this help\n",
	  prog );
}

void version()
{
  fprintf(stderr,"%s\n", PACKAGE_STRING);
}


int main( argc, argv )
int argc;
char **argv;
{
  FILE *fp;
  char *prog = argv[0];
  char *op,c;
  char *deli;
  int total = 0, nof = 1, files_processed = 0;
  int deli_opt = 0;


  for (argv++; *argv && argv[0][0] == '-' && argv[0][1]; argv++) {
    for (op = &argv[0][1]; *op; op++) {
      switch (*op) {
      case 'D':
	deli_opt = TRUE;
	deli = op + 1;
	while(*(++op + 1))
	  ;
	break;
      case 'F':
	if (digitstr(op + 1) == FALSE)
	  usage(prog);
	nof = atoi(op + 1);
	while(*(++op + 1))
	  ;
	break;
      case 's':
	code_type = 1;
	break;
      case 'e':
	code_type = 0;
	break;
      case 'h':
	usage(prog);
	exit(0);
	break;
      case 'v':
	version();
	exit(0);
	break;
      default:
	fprintf(stderr,"invalid option -- %c\n", *op);
	usage(prog);
	exit(0);
      }
    } 
  }
 
  if (!deli_opt) { /* default */
    deli = "|";
#ifdef DEBUG
    printf("%s -- delimiter\n",deli); 
#endif
  }

  for (; *argv; *argv++) {
    if ((fp = fopen(*argv, "r")) == NULL) {
      fprintf(stderr, "Can't open %s\n", *argv);
      exit(1);
    }
    dance(fp, nof, deli); 	
    fclose(fp);
    files_processed++;
  }
  
  if (files_processed == 0)
    dance(stdin, nof, deli); 	 
  return 0;
}

