.\" Copyright 2001 Hilofumi Yamamoto (yamagen@ucsd.edu)
.\"
.\" Permission is granted to make and distribute verbatim copies of this
.\" manual provided the copyright notice and this permission notice are
.\" preserved on all copies.
.\"
.\" Permission is granted to copy and distribute modified versions of this
.\" manual under the conditions for verbatim copying, provided that the
.\" entire resulting derived work is distributed under the terms of a
.\" permission notice identical to this one
.\" 
.\" Formatted or processed versions of this manual, if unaccompanied by
.\" the source, must acknowledge the copyright and authors of this work.
.\" 
.TH JR 3  "June 30, 2007" "GNU" "Japanese Strings Handling Handbook"
.SH NAME
jr \- Japanese String Reverser
.SH SYNOPSIS
.nf
.B % jr [-Fn] [-Dc] [file ...]
     Fn .. (n)th the field will be reversed (default 1).
     Dc .. (c)haracter will be regarded as a delimiter (default '|').
     s ... SJIS Kanji code
     e ... EUC  Kanji code
     v ... shows Version
     h ... shows this help
.fi
.SH DESCRIPTION
The \fBjr\fP is Japanese String Reverser, which displays Japanese
strings reversely.
.PP
The \fBjr\fP deals with Japanese coded strings EUC or SJIS.
Pipe and file redirection are also available.
.PP
.SH "OPTIONS"
.br
\fB-Fn\fP assign the field to make the target string reverse.
"n"  is the field number of the target.
.br
\fB-Dc\fP assign the field separater implicitly.
"c" is the delimiter character. The default value is '|'. 
.br
.SH "CONFORMING TO"
Japanese Strings Handling Handbook 1.1
.SH "SEE ALSO"
.BR jk "(3), " ksf "(3), " krf "(3), " kh "(3), " r2z "(3)
.SH "AUTHOR"
Hilofumi Yamamoto, University of California, San Diego
yamagen@ucsd.edu

